#include <alloc.h>
#include "consola.h"
#include "memoria.h"
#include "varios.h"

TParrafo ParrafoMonton; /* Parrafo actual de la memoria disponible */
TParrafo NumParrafos; /* Numero de parrafos disponibles */
TParrafo NumParrafosInicial; /* Numero de parrafos disponibles inicialmente */

TParrafo AsignarMemoria(long lbytes)
{
	TParrafo tpnum;
	TParrafo tpmem;

	/* Calculo del numero de parrafos solicitados */
	if ((lbytes % BYTESPARRAFO) != 0) tpnum = (lbytes / BYTESPARRAFO) + 1;
	else tpnum = lbytes /BYTESPARRAFO;

	if (tpnum > NumParrafos) return 0;
	tpmem = ParrafoMonton;
	ParrafoMonton += tpnum;
	NumParrafos -= tpnum;
	return tpmem;
}

int InicializacionMemoria(void)
{
	unsigned long ulmemoria;
	void far *pinicio;

	if ((ulmemoria = farcoreleft()) == 0) return 1;
	if ((pinicio = farmalloc(ulmemoria)) == 0) return 2;
	if (FP_OFF(pinicio) == 0) ParrafoMonton = FP_SEG(pinicio);
	else ParrafoMonton = FP_SEG(pinicio) + 1;
	NumParrafos = ulmemoria / BYTESPARRAFO;
	NumParrafosInicial = NumParrafos;
	return 0;
}
