#include "sistema.h"

void Prologo(int nArg,  void *(nFuncion)(int))
{
	(*nFuncion)(nArg);
	MHFinHilo();
}

int MHNuevoHilo(pHiloFunc pHFuncion, int Arg)
{
	_AX = SNUEVOHILO;
	_BX = (int)pHFuncion;
	_CX = Arg;
	_DX = (int)Prologo;
	asm int INT_SISTEMA;
	return _AX;
}

int MHTerminarHilo(int IdHilo)
{
	_AX = STERMINARHILO;
	_BX = IdHilo;
	asm int INT_SISTEMA;
	return _AX;
}

int MHFinHilo(void)
{
	_AX = SFINHILO;
	asm int INT_SISTEMA;
	return _AX;
}

int MHDormirHilo(unsigned long NumTicks)
{
	_AX = SDORMIRHILO;
	_BX = NumTicks;
	_CX = 0; /*NumTicks >> 8; */
	asm int INT_SISTEMA;
	return _AX;
}

int MHEscribirCaracter(unsigned char c)
{
	_BX = c;
	_AX = SESCRIBIRCARACTER;
	asm int INT_SISTEMA;
	return _AX;
}

int MHEscribirCadena(const char far *cadena)
{
	_AX = SESCRIBIRCADENA;
	_DX = FP_SEG(cadena);
	_BX = FP_OFF(cadena);
	asm int INT_SISTEMA;
	return _AX;
}

char MHLeerCaracter(void)
{
	_AX = SLEERCARACTER;
	asm int INT_SISTEMA;
	return (char)_AX;
}